- Main Page
- Classes
- Files
- Directories
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions

# FbxAnimCurveFilterConstantKeyReducer Class Reference

Search for all occurrences

## Detailed Description

Constant key reducing filter.

Filter to test if each key is really necessary to define the curve at a definite degree of precision. It filters recursively from the strongest difference first. All useless keys are eliminated.

Definition at line 265 of file fbxanimcurvefilters.h.

`#include <fbxanimcurvefilters.h>`

Inheritance diagram for FbxAnimCurveFilterConstantKeyReducer:
[legend]

List of all members.

## Public Member Functions
| FbxAnimCurveFilterConstantKeyReducer ()
| Constructor.
virtual | ~FbxAnimCurveFilterConstantKeyReducer ()
| Destructor.
virtual const char * | GetName () const
| Get the name of the filter.
virtual bool | Apply (FbxAnimCurveNode &pCurveNode)
| Apply filter on all the curves of an animation curve node.
virtual bool | Apply (FbxAnimCurve &pCurve)
| Apply filter on an animation curve.
virtual void | Reset ()
| Reset the filter to its default parameters.
double | GetDerivativeTolerance () const
| Get the current derivative tolerance.
void | SetDerivativeTolerance (double pValue)
| Set the derivative tolerance.
double | GetValueTolerance () const
| Get the tolerance value.
void | SetValueTolerance (double pValue)
| Set the tolerance value.
bool | GetKeepFirstAndLastKeys () const
| Get the state of the KeepFirstAndLastKeys flag.
void | SetKeepFirstAndLastKeys (bool pKeepFirstAndLastKeys)
| Set the state of the KeepFirstAndLastKeys flag.
bool | GetKeepOneKey () const
| Get the state of the KeepOneKey flag.
void | SetKeepOneKey (bool pKeepOneKey)
| Set the state of the KeepOneKey flag.
void | SetKeepNotPureAutoKeys (bool pKeep)
| Tell the filter to keep CUBIC curve keys which are not pure AUTO.
void | SetTranslationThreshold (double pTranslationThreshold)
void | SetRotationThreshold (double pRotationThreshold)
void | SetScalingThreshold (double pScalingThreshold)
void | SetDefaultThreshold (double pDefaultThreshold)
void | SetModes (bool pExporting, FbxIOSettings &pIOS)
## Exposed parent class methods.
virtual bool | Apply (FbxAnimStack *pAnimStack)
| Apply filter to all the curves stored in the animation stack.
virtual bool | Apply (FbxObject *pObj, FbxAnimStack *pAnimStack)
| Apply filter to all the animated properties of the object.
virtual bool | Apply (FbxAnimCurve **pCurve, int pCount)
| Apply filter on an array of animation curves.

## Constructor & Destructor Documentation

FbxAnimCurveFilterConstantKeyReducer | ( |  | ) |

Constructor.

virtual ~FbxAnimCurveFilterConstantKeyReducer | ( |  | ) | `[inline, virtual]`

Destructor.

Definition at line 272 of file fbxanimcurvefilters.h.

    {};

## Member Function Documentation

virtual const char* GetName | ( |  | ) | const `[virtual]`

Search for all occurrences

Get the name of the filter.

Returns:
  Pointer to name.

Reimplemented from FbxAnimCurveFilter.

virtual bool Apply | ( | FbxAnimStack * | pAnimStack | ) | `[inline, virtual]`

Search for all occurrences

Apply filter to all the curves stored in the animation stack.

Parameters:

  pAnimStack | Animation stack where to retrieve the animation curves

Returns:
  `true` if the curve filtering operation was successful, `false` otherwise.

Reimplemented from FbxAnimCurveFilter.

Definition at line 283 of file fbxanimcurvefilters.h.

    { return FbxAnimCurveFilter::Apply(pAnimStack); }

virtual bool Apply | ( | FbxObject * | pObj,
|  | FbxAnimStack * | pAnimStack
| ) |  | `[inline, virtual]`

Search for all occurrences

Apply filter to all the animated properties of the object.

Parameters:

  pObj | Object containing the animated properties to which the filter is applied.
  pAnimStack | Animation stack where to retrieve the animation curves

Returns:
  `true` if the curve filtering operation was successful, `false` otherwise.

Reimplemented from FbxAnimCurveFilter.

Definition at line 284 of file fbxanimcurvefilters.h.

    { return FbxAnimCurveFilter::Apply(pObj, pAnimStack); }

virtual bool Apply | ( | FbxAnimCurve ** | pCurve,
|  | int | pCount
| ) |  | `[inline, virtual]`

Search for all occurrences

Apply filter on an array of animation curves.

Parameters:

  pCurve | Array of curves to which the filter is applied.
  pCount | Number of curves in the array.

Returns:
  `true` if the curve filtering operation was successful, `false` otherwise.

Reimplemented from FbxAnimCurveFilter.

Definition at line 285 of file fbxanimcurvefilters.h.

    { return FbxAnimCurveFilter::Apply(pCurve, pCount); }

virtual bool Apply | ( | FbxAnimCurveNode & | pCurveNode | ) | `[virtual]`

Search for all occurrences

Apply filter on all the curves of an animation curve node.

Parameters:

  pCurveNode | Curve node to which the filter is applied.

Returns:
  `true` if the curve filtering operation was successful, `false` otherwise.

Remarks:
  This method collects all the FbxAnimCurve objects connected to the curve node and calls Apply(FbxAnimCurve**, int)

Reimplemented from FbxAnimCurveFilter.

virtual bool Apply | ( | FbxAnimCurve & | pCurve | ) | `[virtual]`

Search for all occurrences

Apply filter on an animation curve.

Parameters:

  pCurve | Curve to which the filter is applied.

Returns:
  `true` if the curve filtering operation was successful, `false` otherwise.

Implements FbxAnimCurveFilter.

virtual void Reset | ( |  | ) | `[virtual]`

Search for all occurrences

Reset the filter to its default parameters.

Reimplemented from FbxAnimCurveFilter.

double GetDerivativeTolerance | ( |  | ) | const

Search for all occurrences

Get the current derivative tolerance.

Returns:
  The value of the current derivative tolerance.

void SetDerivativeTolerance | ( | double | pValue | ) |

Search for all occurrences

Set the derivative tolerance.

Parameters:

  pValue | Value derivative tolerance.

double GetValueTolerance | ( |  | ) | const

Search for all occurrences

Get the tolerance value.

Returns:
  The tolerance value.

void SetValueTolerance | ( | double | pValue | ) |

Search for all occurrences

Set the tolerance value.

Parameters:

  pValue | Tolerance value.

bool GetKeepFirstAndLastKeys | ( |  | ) | const

Search for all occurrences

Get the state of the KeepFirstAndLastKeys flag.

Returns:
  `true` if the filter keeps the first and last keys.

void SetKeepFirstAndLastKeys | ( | bool | pKeepFirstAndLastKeys | ) |

Search for all occurrences

Set the state of the KeepFirstAndLastKeys flag.

Parameters:

  pKeepFirstAndLastKeys | Set to `true` if you want the filter to keep the first and last keys.

bool GetKeepOneKey | ( |  | ) | const

Search for all occurrences

Get the state of the KeepOneKey flag.

If all the keys are constant and this flag is c\ true, the filter will keep the first key. If all the keys are constant and this flag is c\ false, the filter will delete all the keys.

Returns:
  `true` if the filter keeps the first key when all keys are constant.

void SetKeepOneKey | ( | bool | pKeepOneKey | ) |

Search for all occurrences

Set the state of the KeepOneKey flag.

If all the keys are constant and this flag is c\ true, the filter will keep the first key. If all the keys are constant and this flag is c\ false, the filter will delete all the keys.

Parameters:

  pKeepOneKey | Set to `true` if you want the filter to keep the first key when all keys are constant.

void SetKeepNotPureAutoKeys | ( | bool | pKeep | ) |

Search for all occurrences

Tell the filter to keep CUBIC curve keys which are not pure AUTO.

Parameters:

  pKeep | KeepNotPureAutoKeys flag.

void SetTranslationThreshold | ( | double | pTranslationThreshold | ) |

Search for all occurrences

void SetRotationThreshold | ( | double | pRotationThreshold | ) |

Search for all occurrences

void SetScalingThreshold | ( | double | pScalingThreshold | ) |

Search for all occurrences

void SetDefaultThreshold | ( | double | pDefaultThreshold | ) |

Search for all occurrences

void SetModes | ( | bool | pExporting,
|  | FbxIOSettings & | pIOS
| ) |  |

Search for all occurrences

The documentation for this class was generated from the following file:

- fbxsdk/scene/animation/fbxanimcurvefilters.h

FbxAnimCurveFilterConstantKeyReducer FbxAnimCurveFilterConstantKeyReducer FbxAnimCurveFilterConstantKeyReducer FbxAnimCurveFilterConstantKeyReducer FbxAnimCurveFilterConstantKeyReducer FbxAnimCurveFilterConstantKeyReducer FbxAnimCurveFilterConstantKeyReducer FbxAnimCurveFilterConstantKeyReducer FbxAnimCurveFilterConstantKeyReducer FbxAnimCurveFilterConstantKeyReducer
FbxAnimCurveFilterConstantKeyReducer FbxAnimCurveFilterConstantKeyReducer FbxAnimCurveFilterConstantKeyReducer FbxAnimCurveFilterConstantKeyReducer FbxAnimCurveFilterConstantKeyReducer FbxAnimCurveFilterConstantKeyReducer FbxAnimCurveFilterConstantKeyReducer FbxAnimCurveFilterConstantKeyReducer FbxAnimCurveFilterConstantKeyReducer FbxAnimCurveFilterConstantKeyReducer